/*****************************************************************************
* Copyright (c) Bridgetek Pte Ltd.
* Software License Agreement
*
* This code is provided as an example only and is not guaranteed by Bridgetek. 
* BRIDGETEK accept no responsibility for any issues resulting from its use. 
* The developer of the final application incorporating any parts of this 
* sample project is responsible for ensuring its safe and correct operation 
* and for any consequences resulting from its use.
*****************************************************************************/
/**
* @file  App_Imageviewer
* @brief Sample application to demonstrate EVE primitives and widgets.
Versoin 5.0 - April/17/2017 - Restructure source code
*/


#include "Platform.h"
#include "App_Common.h"
#if defined(FT9XX_PLATFORM)
#include "ff.h"
#endif
/* Global used for context hal */
Gpu_Hal_Context_t host,*phost;

#if defined(FT9XX_PLATFORM)
	FATFS FatFs;
FIL 			 CurFile;
FRESULT          fResult;
#endif

typedef struct 
{
	  char name[20];
	  uint32_t file_size;
}Image;
Image Image_prop[20];


static uint16_t cts=0;
FILE *pfile;
static uint32_t filesize;
          
static uchar8_t istouch()
{
  return !(Gpu_Hal_Rd16(phost,REG_TOUCH_RAW_XY) & 0x8000);
}

uint8_t isHighResolution(char *fn){
	uint8_t fileLength = strlen(fn);
	if(fileLength>5 && fn[fileLength-5]=='H' && fn[fileLength-4]=='.' && (fn[fileLength-3]=='j' || fn[fileLength-3]=='J') && (fn[fileLength-2]=='p' || fn[fileLength-2]=='P') && (fn[fileLength-1]=='g' || fn[fileLength-1]=='G'))
		return 1;
	else
		return 0;
}

#define MAX_FILES_TO_RETRIEVE 20

uint16_t List_Out_files()
{ 	
	uint16_t nooffiles=0;

#if defined(MSVC_PLATFORM)|| defined(MSVC_FT800EMU)
    char *path = "..\\..\\Test";
	struct _finddata_t Files;
	long file_spec;	
	if(!_chdir(path))
#if defined(DISPLAY_RESOLUTION_WQVGA) || defined(DISPLAY_RESOLUTION_QVGA)
		file_spec = _findfirst("*.jpg*", &Files); 
#elif defined(DISPLAY_RESOLUTION_WVGA)
		file_spec = _findfirst("*H.jpg*", &Files); 
#endif
	else 
		return nooffiles;
#if defined(DISPLAY_RESOLUTION_WQVGA) || defined(DISPLAY_RESOLUTION_QVGA)
	if(!isHighResolution(Files.name)){
		strcpy_P(Image_prop[nooffiles].name,Files.name);
		Image_prop[nooffiles].file_size = (Files.size+3)&~3;
		nooffiles++;
	}
#elif defined(DISPLAY_RESOLUTION_WVGA)
	strcpy_P(Image_prop[nooffiles].name,Files.name);
	Image_prop[nooffiles].file_size = (Files.size+3)&~3;
	nooffiles++;
#endif


	while(_findnext(file_spec,&Files)==0)
	{
#if defined(DISPLAY_RESOLUTION_WQVGA) || defined(DISPLAY_RESOLUTION_QVGA)
	if(!isHighResolution(Files.name)){
		strcpy_P(Image_prop[nooffiles].name,Files.name);
		Image_prop[nooffiles].file_size = (Files.size+3)&~3;
		nooffiles++;
	}
#elif defined(DISPLAY_RESOLUTION_WVGA)
		strcpy_P(Image_prop[nooffiles].name,Files.name);
		Image_prop[nooffiles].file_size = (Files.size+3)&~3;
		nooffiles++;
#endif
	}
	return nooffiles;
#endif


#if defined(FT9XX_PLATFORM)
	FRESULT res;
	DIR dir;
	FILINFO fno;
	uint8_t i=1, fileLength;
	char *fn;

	res = f_opendir(&dir, "");

	if(res == FR_OK){
		//i = strlen(".");
		for(;;){
			res = f_readdir(&dir, &fno);
			if(res != FR_OK || fno.fname[0] == 0) break;
			if(fno.fname[0] == '.') continue;
			fn = fno.fname;
			if(fno.fattrib & AM_DIR){
			}
			else{
				fileLength = strlen(fn);
#if defined(DISPLAY_RESOLUTION_WVGA)
				if(fileLength>5 && fn[fileLength-5]=='H' && fn[fileLength-4]=='.' && (fn[fileLength-3]=='j' || fn[fileLength-3]=='J') && (fn[fileLength-2]=='p' || fn[fileLength-2]=='P') && (fn[fileLength-1]=='g' || fn[fileLength-1]=='G')){
#else
					if(fileLength>5 && fn[fileLength-5]!='H' && fn[fileLength-4]=='.' && (fn[fileLength-3]=='j' || fn[fileLength-3]=='J') && (fn[fileLength-2]=='p' || fn[fileLength-2]=='P') && (fn[fileLength-1]=='g' || fn[fileLength-1]=='G')){
#endif
					strcpy(Image_prop[nooffiles].name,fn);
					//Image_prop[nooffiles].file_size = (fno.fsize+3)&~3;
					Image_prop[nooffiles].file_size = fno.fsize;
					printf("Num:%d , Name:%s , Size:%d\n",nooffiles, Image_prop[nooffiles].name, Image_prop[nooffiles].file_size);
					nooffiles++;
					if(nooffiles>=MAX_FILES_TO_RETRIEVE)
						break;
				}
			}
		}
	}
	else
	{	printf("\n fail");}
	//f_closedir(&dir);
	return nooffiles;
#endif
}


void Load_Jpeg()
{
	uint8_t imbuff[8192];
	int32_t blocklen;
	int32_t bytesRead;
	while(filesize > 0)
	{
		blocklen = filesize>8192?8192:filesize;
#if defined(MSVC_PLATFORM) || defined(MSVC_FT800EMU)
		bytesRead = fread(imbuff,1,blocklen,pfile);							/* copy the data into pbuff and then transfter it to command buffer */
#elif defined(FT9XX_PLATFORM)
		fResult = f_read(&CurFile, imbuff, blocklen, &bytesRead);
#endif
		filesize -= blocklen;
		Gpu_Hal_WrCmdBuf(phost,imbuff,blocklen);				/* copy data continuously into command memory */
	}
#if defined(MSVC_PLATFORM) || defined(MSVC_FT800EMU)
	fclose(pfile);												/* close the opened jpg file */
#elif defined(FT9XX_PLATFORM)
	f_close(&CurFile);
#endif
}

static uint16_t nooffiles = 0;
void Loadimage2ram(uint8_t bmphandle)
{
#if defined(MSVC_PLATFORM) || defined(MSVC_FT800EMU)
	pfile = fopen(Image_prop[cts].name,"rb");			// read Binary (rb)
#elif defined(FT9XX_PLATFORM)
	char newName[16]="0:";
	char *dest;
	do{
	dest = strcat(newName,Image_prop[cts].name);
	}while(dest != newName);
	 //strcat(newName,"leavesH.jpg");
	fResult = f_open(&CurFile, Image_prop[cts].name, FA_READ | FA_OPEN_EXISTING);
	if(fResult != FR_OK)
		printf("Unable to open file: %s", newName);
	fflush(stdout);
#endif

	filesize = Image_prop[cts].file_size;
	cts++;
    if(cts>(nooffiles-1)) cts = 0;

#if defined(MSVC_PLATFORM) || defined(MSVC_FT800EMU)
	fseek(pfile,0,SEEK_SET);
#endif

	
	Gpu_Hal_WrCmd32(phost,CMD_LOADIMAGE);
#if defined(DISPLAY_RESOLUTION_QVGA) || defined(DISPLAY_RESOLUTION_WQVGA) || defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
	Gpu_Hal_WrCmd32(phost,(bmphandle ? 131072L : 100));
#elif defined(DISPLAY_RESOLUTION_WVGA)
	Gpu_Hal_WrCmd32(phost,(bmphandle ? 400000L : 300));  //different ram location for bigger bitmap

#endif
	Gpu_Hal_WrCmd32(phost,OPT_NODL); 
	fflush(stdout);
	Load_Jpeg();
}





void Imageviewer()
{
  uint16_t i,xv;
  uint16_t aspect_ratio = 0;
  uint16_t transform = 273L,boot=1, imgWidth=512, imgHeight=308, refGradHeight=64;
  
#if defined(DISPLAY_RESOLUTION_WQVGA) || defined(DISPLAY_RESOLUTION_QVGA) || defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
  int32_t  px = ((DispWidth-320)/2)+aspect_ratio,
	      x = ((DispWidth-320)/2)+aspect_ratio,
	      tracker=0,temp_x;
#elif  defined(DISPLAY_RESOLUTION_WVGA)
  int32_t  px = ((DispWidth-512)/2)+aspect_ratio,x = ((DispWidth-512)/2)+aspect_ratio,tracker=0,temp_x;
#else
  int32_t  px = ((DispWidth-512)/2)+aspect_ratio,x = ((DispWidth-512)/2)+aspect_ratio,tracker=0,temp_x;
#endif


  
  uint8_t 
 		r = 1,loaded = 0,Touch_detected=0;

  temp_x = x;
  
  Gpu_Hal_Wr16(phost,REG_VOL_SOUND,100);
  Gpu_Hal_Wr16(phost,REG_SOUND,0x51);
 
	nooffiles = List_Out_files();
	if(nooffiles==0)
	{
		printf("\n Files not found");
		return;
	}	


  Loadimage2ram(r);	
#if defined(DISPLAY_RESOLUTION_WQVGA) || defined(DISPLAY_RESOLUTION_QVGA) || defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
  for (i = 0; i < 64; i++)
	Gpu_Hal_Wr8(phost,i,96- (3 * i / 2));
#elif defined(DISPLAY_RESOLUTION_WVGA)
  for (i = 0; i < 180; i++){
	Gpu_Hal_Wr8(phost,i,90-(i / 2));
  }
#endif
  App_Set_CmdBuffer_Index(0);
  Gpu_CoCmd_Dlstart(phost);    
  App_WrCoCmd_Buffer(phost,CLEAR(1,1,1));
  App_WrCoCmd_Buffer(phost, BITMAP_HANDLE(r));
#if defined(DISPLAY_RESOLUTION_WQVGA) || defined(DISPLAY_RESOLUTION_QVGA) || defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
  App_WrCoCmd_Buffer(phost, BITMAP_SOURCE((r ? 131072L : 100)));
  App_WrCoCmd_Buffer(phost,BITMAP_LAYOUT(RGB565,320L*2,194));
  App_WrCoCmd_Buffer(phost,BITMAP_SIZE(NEAREST,BORDER,BORDER,320,194));
#elif defined(DISPLAY_RESOLUTION_WVGA)
  App_WrCoCmd_Buffer(phost, BITMAP_SOURCE((r ? 400000L : 300)));
  App_WrCoCmd_Buffer(phost,BITMAP_LAYOUT(RGB565,imgWidth*2,imgHeight));
  App_WrCoCmd_Buffer(phost,BITMAP_LAYOUT_H((imgWidth*2)>>10,imgHeight>>9));
  App_WrCoCmd_Buffer(phost,BITMAP_SIZE(NEAREST,BORDER,BORDER,imgWidth,imgHeight));
  App_WrCoCmd_Buffer(phost,BITMAP_SIZE_H(imgWidth>>9,imgHeight>>9));
#endif
  //reflection gradient
#if defined(DISPLAY_RESOLUTION_WQVGA) || defined(DISPLAY_RESOLUTION_QVGA)  || defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
  App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(2));
  App_WrCoCmd_Buffer(phost,BITMAP_SOURCE(0));
  App_WrCoCmd_Buffer(phost,BITMAP_LAYOUT(L8, 1, 64));
  App_WrCoCmd_Buffer(phost,BITMAP_SIZE(NEAREST, REPEAT, BORDER, DispWidth,64));
#elif defined(DISPLAY_RESOLUTION_WVGA)
  App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(2));
  App_WrCoCmd_Buffer(phost,BITMAP_SOURCE(0));
  App_WrCoCmd_Buffer(phost,BITMAP_LAYOUT(L8, 1, 180));
  App_WrCoCmd_Buffer(phost,BITMAP_SIZE(NEAREST, REPEAT, BORDER, DispWidth,180));
  App_WrCoCmd_Buffer(phost,BITMAP_SIZE_H(DispWidth>>9,0));
#endif
  App_WrCoCmd_Buffer(phost,BEGIN(BITMAPS));
#if defined(DISPLAY_RESOLUTION_WQVGA) || defined(DISPLAY_RESOLUTION_QVGA) || defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
  App_WrCoCmd_Buffer(phost,VERTEX2II(x, (10+aspect_ratio),r, 0));	
#elif defined(DISPLAY_RESOLUTION_WVGA)
  App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(r));
  App_WrCoCmd_Buffer(phost,CELL(0));
  App_WrCoCmd_Buffer(phost,VERTEX2F(x*16, (10+aspect_ratio)*16));
#endif
  App_WrCoCmd_Buffer(phost,DISPLAY());
  Gpu_CoCmd_Swap(phost);
  App_Flush_Co_Buffer(phost); 
  Gpu_Hal_WaitCmdfifo_empty(phost);	


  while(1)
  {
    Gpu_CoCmd_Dlstart(phost);  
    App_WrCoCmd_Buffer(phost,CLEAR(1,1,1));
    Gpu_CoCmd_Gradient(phost,0, DispHeight/2, 0x000000, 0, DispHeight, 0x605040);
    App_WrCoCmd_Buffer(phost,COLOR_RGB(255,255,255));
    App_WrCoCmd_Buffer(phost,BEGIN(BITMAPS));
    if (x != temp_x) 
    {
      App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(r ^ 1));
      App_WrCoCmd_Buffer(phost,CELL(0));
#if defined(DISPLAY_RESOLUTION_WVGA)
      App_WrCoCmd_Buffer(phost,VERTEX2F(16 * (x-656), 16 *(10+aspect_ratio)));
#elif defined(DISPLAY_RESOLUTION_QVGA) || defined(DISPLAY_RESOLUTION_WQVGA)  ||  defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
      App_WrCoCmd_Buffer(phost,VERTEX2F(16 * (x-400), 16 *(10+aspect_ratio)));
#endif
    }
    
#if defined(DISPLAY_RESOLUTION_QVGA) || defined(DISPLAY_RESOLUTION_WQVGA)  ||  defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
    App_WrCoCmd_Buffer(phost,VERTEX2II(x, (10+aspect_ratio),r, 0));	
#elif defined(DISPLAY_RESOLUTION_WVGA)
	App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(r));
	App_WrCoCmd_Buffer(phost,VERTEX2F(x*16, (10+aspect_ratio)*16));	
#endif
    App_WrCoCmd_Buffer(phost,SAVE_CONTEXT());
    App_WrCoCmd_Buffer(phost,COLOR_MASK(0,0,0,1));
    App_WrCoCmd_Buffer(phost,BLEND_FUNC(ONE, ZERO));


	#if defined(DISPLAY_RESOLUTION_QVGA) ||  defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
	App_WrCoCmd_Buffer(phost,VERTEX2II(x, 207, 2, 0));
	#elif defined(DISPLAY_RESOLUTION_WQVGA)
    App_WrCoCmd_Buffer(phost,VERTEX2II(0, 212, 2, 0));
	#elif defined(DISPLAY_RESOLUTION_WVGA)
	App_WrCoCmd_Buffer(phost,VERTEX2II(0, 300, 2, 0));
	#endif
    App_WrCoCmd_Buffer(phost,COLOR_MASK(1,1,1,1));
    App_WrCoCmd_Buffer(phost,BLEND_FUNC(DST_ALPHA, ONE_MINUS_DST_ALPHA));

#if defined(DISPLAY_RESOLUTION_QVGA) || defined(DISPLAY_RESOLUTION_WQVGA)  ||  defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
    Gpu_CoCmd_LoadIdentity(phost);
    Gpu_CoCmd_Translate(phost,(temp_x)*65536L, 65536L*96.5);
    Gpu_CoCmd_Scale(phost,1*65536, 65536*-1);
    Gpu_CoCmd_Translate(phost,-(temp_x)*65536L, 65536L*-96.5);
    Gpu_CoCmd_SetMatrix(phost);
#elif defined(DISPLAY_RESOLUTION_WVGA)
    Gpu_CoCmd_LoadIdentity(phost);
    //Gpu_CoCmd_Translate(phost,(temp_x)*65536L, 65536L*(10+aspect_ratio));
    //Gpu_CoCmd_Scale(phost,1*65536, 65536*-1);
    //Gpu_CoCmd_Translate(phost,-(temp_x)*65536L, 65536L*-(10+aspect_ratio));

    Gpu_CoCmd_Translate(phost,256*65536L, 65536L*150);
    Gpu_CoCmd_Scale(phost,1*65536, 65536*-1);
    Gpu_CoCmd_Translate(phost,-256*65536L, 65536L*-150);
    Gpu_CoCmd_SetMatrix(phost);
#endif
    
    if (x != temp_x)
    {
	App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(r ^ 1));
	App_WrCoCmd_Buffer(phost,CELL(0));
#if defined(DISPLAY_RESOLUTION_QVGA) || defined(DISPLAY_RESOLUTION_WQVGA)  ||  defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
	App_WrCoCmd_Buffer(phost,VERTEX2F(16 * (x-400), 16 * 212));
#elif defined(DISPLAY_RESOLUTION_WVGA)
	App_WrCoCmd_Buffer(phost,VERTEX2F(16 * (x-656), 16 * 365));
#endif
    }
	#if defined(DISPLAY_RESOLUTION_QVGA) ||  defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
	App_WrCoCmd_Buffer(phost,VERTEX2II(x, 207, r, 0));
	#elif defined(DISPLAY_RESOLUTION_WQVGA)
    App_WrCoCmd_Buffer(phost,VERTEX2II(x, 212, r, 0));
	#elif defined(DISPLAY_RESOLUTION_WVGA)
		App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(r));
		App_WrCoCmd_Buffer(phost,VERTEX2F(x*16, 365*16));
	#endif
    App_WrCoCmd_Buffer(phost,RESTORE_CONTEXT());
	//printf("px: %d, temp_x: %d, loaded: %d, boot: %d\n",px, temp_x, loaded, boot);
    if(px == temp_x && loaded==0 && boot==0) 
    {  
#if defined(DISPLAY_RESOLUTION_QVGA) || defined(DISPLAY_RESOLUTION_WQVGA)  ||  defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
      App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(r^1));
      App_WrCoCmd_Buffer(phost,BITMAP_SOURCE(((r^1) ? 131072L : 100)));
      App_WrCoCmd_Buffer(phost,BITMAP_LAYOUT(RGB565,320L*2,194));
      App_WrCoCmd_Buffer(phost,BITMAP_SIZE(NEAREST,BORDER,BORDER,320,194));
#elif defined(DISPLAY_RESOLUTION_WVGA)
      App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(r^1));
      App_WrCoCmd_Buffer(phost,BITMAP_SOURCE(((r^1) ? 400000L : 300)));
      App_WrCoCmd_Buffer(phost,BITMAP_LAYOUT(RGB565,imgWidth*2,imgHeight));
	  App_WrCoCmd_Buffer(phost,BITMAP_LAYOUT_H((imgWidth*2)>>10,imgHeight>>9));
      App_WrCoCmd_Buffer(phost,BITMAP_SIZE(NEAREST,BORDER,BORDER,imgWidth,imgHeight));
	  App_WrCoCmd_Buffer(phost,BITMAP_SIZE_H(imgWidth>>9,imgHeight>>9));
#endif
      Loadimage2ram(r ^ 1);
      loaded = 1;    
   }

    App_WrCoCmd_Buffer(phost,DISPLAY());
    Gpu_CoCmd_Swap(phost);
    App_Flush_Co_Buffer(phost);
    Gpu_Hal_WaitCmdfifo_empty(phost);
	boot = 0;
  tracker = Gpu_Hal_Rd32(phost,REG_TOUCH_SCREEN_XY);
  if (loaded && x == temp_x && tracker!=0x80008000)
  {
    Gpu_Hal_Wr8(phost,REG_PLAY,1);	// Play the Sound	
    x = DispWidth; 
    r ^= 1;
    loaded = 0;	
  }
  xv = 1 + x / 16;
  px = x;
  x = MAX(temp_x, x - xv);
 }
}

#if defined(ARDUINO_PLATFORM)
prog_char8_t * const info[] =
#else
char *info[] =
#endif 
{  "EVE ImageViewer Application",
    "APP to demonstrate interactive Jpeg decode,",
    "using Blend function, Bitmap flip,", 
    "& Jpeg decode"
}; 

#if defined MSVC_PLATFORM | defined FT9XX_PLATFORM
/* Main entry point */
int32_t main(int32_t argc,char8_t *argv[])
#endif
#if defined(ARDUINO_PLATFORM)||defined(MSVC_FT800EMU)
void setup()
#endif
{
    phost = &host;
    /* Init HW Hal */
    App_Common_Init(phost);
    /* Show Logo, do calibration and display welcome screeen */
    App_Common_Start(phost,info);
    /* Main application */
    Imageviewer();    
    /* Close all the opened handles */
    App_Common_Close(phost);

#ifdef MSVC_PLATFORM
	return 0;
#endif
}

void loop()
{
}



/* Nothing beyond this */













